local L = LibStub("AceLocale-3.0"):GetLocale("SetTheory", true)

if  SetTheory then
	local cb = {};
	cb.name = "SetTheory_CancelBuff"
	cb.desc = L["Cancel Buff"]

	function cb.set(opts)
		if not opts.buff then return end
		if opts.buff then CancelUnitBuff("player", opts.buff) end
	end
	
	function buffs()
		local buffs = {}
		for i=1,40 do
			local buff = UnitBuff("player", i)
			if not buff then break end
			buffs[buff] = buff
		end
		return buffs
	end

	cb.opts = {
		type = "group",
		name = L["Cancel Buff"],
		handler = SetTheory,
		get = "GetActionOption",
		set = "SetActionOption",
		args = {
			actionInstructions = {
				type = "description",
				name = L["Select a current buff or type the name of a currently inactive buff you'd like to cancel"],
				order = 0,
			},
			currentBuff = {
				type = "select",
				name = L["Current buffs"],
				desc = L["Select a currently active buff"],
				values = buffs,
				order = 10,
				set = function(i, v) SetTheory:SetActionOptionByName(i[#i-3], i[#i-1], 'buff', v) end
			},
			buff = {
				name = L["Buff Name"],
				desc = L["Type the name of the buff name."],
				type = "input",
				order = 20,
			},
		}
	}

	SetTheory:RegisterAction(cb)
end
