local L = LibStub("AceLocale-3.0"):GetLocale("SetTheory", true)

if Talented and SetTheory then
	local talented = {};
	talented.name = "SetTheory_Talented"
	talented.desc = L["Talented"]

	function talented.set(opts)
		if not opts.template then return end
		local oldTemplate = Talented.template
		Talented.template = Talented.db.global.templates[opts.template]
		Talented:UnpackTemplate(Talented.template)
		Talented:ApplyCurrentTemplate()
		Talented.template = oldTemplate
		Talented:EnableUI(true)
	end

	function templates()
		local ret = {}
		for name, code in pairs(Talented.db.global.templates) do
			local class = code.class
			if not class and code.code then _, class = Talented:StringToTemplate(code.code) end
			if class == select(2, UnitClass("player")) then ret[name] = name end
		end
		return ret
	end

	function exists(i, v)
		local found = false
		for name, code in pairs(Talented.db.global.templates) do
			if name == v then
				local class = code.class
				if not class and code.code then _, class = Talented:StringToTemplate(code.code) end
				if class == select(2, UnitClass("player"))then
					found = true
					break
				end
			end
		end
		return found
	end
	
	talented.opts = {
		type = "group",
		name = L["Talented"],
		handler = SetTheory,
		set = "SetActionOption",
		get = "GetActionOption",
		args = {
			actionInstructions = {
				type = "description",
				name = L["Select which Talented template you'd like to apply"],
				order = 0,
			},
			template = {
				name = L["Template"],
				desc = L["The talented template you'd like to apply"],
				type = "select",
				values = templates,
				validate = exists,
			},
		}
	}

	SetTheory:RegisterAction(talented)
end
