local L = LibStub("AceLocale-3.0"):GetLocale("SetTheory", true)

if TellMeWhen_Settings and SetTheory then
	local tmw = {};
	tmw.name = "SetTheory_TellMeWhen"
	tmw.desc = L["TellMeWhen"]

	function tmw.set(opts)
		local on = {}; local off = {}
		for i, v in pairs(opts) do
			if TellMeWhen_Settings["Groups"][tonumber(i)] then 
				TellMeWhen_Settings["Groups"][tonumber(i)]["Enabled"] = v 
				TellMeWhen_Group_Update(tonumber(i))
				if v then table.insert(on, i) else table.insert(off, i) end
			end
		end
		if #on > 0 then SetTheory:SelectStatus(L['Turned the following TellMeWhen groups on: ']..table.concat(on, ', ')) end
		if #off > 0 then SetTheory:SelectStatus(L['Turned the following TellMeWhen groups off: ']..table.concat(off, ', ')) end
	end
	
	tmw.opts = {
		type = "group",
		name = L["TellMeWhen"],
		handler = SetTheory,
		set = "SetActionOption",
		get = "GetActionOption",
		args = {
			actionInstructions = {
				type = "description",
				name = L["Select which TellMeWhen groups you'd like to enable or disable. Blank = disable, grey = no change, ticked = enable."],
				order = 0,
			},
			['1'] = {
				name = L["Group 1"],
				desc = L["Enable or disable this TellMeWhen group."],
				type = "toggle",
				tristate = true,
			},
			['2'] = {
				name = L["Group 2"],
				desc = L["Enable or disable this TellMeWhen group."],
				type = "toggle",
				tristate = true,
			},
			['3'] = {
				name = L["Group 3"],
				desc = L["Enable or disable this TellMeWhen group."],
				type = "toggle",
				tristate = true,
			},
			['4'] = {
				name = L["Group 4"],
				desc = L["Enable or disable this TellMeWhen group."],
				type = "toggle",
				tristate = true,
			},
		}
	}

	SetTheory:RegisterAction(tmw)
end
